unit Unit1;

interface

uses
  SysUtils, Forms, Classes, StdCtrls, Dialogs, Controls,windows;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
header : array [0..4] of char;
thefile : tfilestream;
Checkheader : string;
begin
//Set the open dialog's filter to be able to open
//Only .EXE files
OpenDialog1.Filter :='Executable Files (*.exe)|*.exe';
//Check whether the open dialog box is executed
if OpenDialog1.Execute then
  begin
    //Open the file as a stream with having access
    //To read from it and also write to it
    thefile :=tfilestream.Create(OpenDialog1.FileName , fmopenreadwrite);
    //If the first radio button is checked , we have to lock the file
    if radiobutton1.Checked = true then
      begin
        //We will Navigate to the first byte of the file
        thefile.Seek(0,sofrombeginning);
        {* We made a variable called HEADER which can contain
           4 Bytes , that will let us read the first 4 byte of
           the file header , in exe files the header most of
           the times is MZ , so we can also read 2 bytes
           but not to left any stones unturned , we will read
           4 bytes from the beginning and header of the file *}
        thefile.Read(header,sizeof(header));
        {* Check if the file header is equal to the file
           Which is already locked by this program *}
        if header[0]=chr(05) then
          begin
            messagebox(form1.Handle , 'This file seem to be Locked already','Already Locked',mb_iconexclamation + mb_ok);
            thefile.Free;            
            exit;
          end;
        {* After reading the 4 first characters the pointer
           Will be navigated to the 4th byte of the file
           So we back it on the first byte again *}
        thefile.Seek(0,sofrombeginning);
        {* If we delete the executable file header it wont be
           an executable file anymore , the file header is MZ
           as we have already talked about it , so if we replace
           it with other characters like chr(05) which is DOT
           Windows wont be able to recognize that file as
           an executable file , so we will do it in the below line *}
        thefile.Write(chr(05) + chr(05) + chr(05) + chr(05),4);
        {* We now seek to the end of file to write and store
           the file's header , there so we can use it when
           unlocking the file .
           We cant also navigate to the last byte of the file
           To write the header there , because some of the
           executable files like Installation files that have
           been made by Installer wise will check the file size
           On theit start up and if the file be bigger that the
           Original size then they will end the setup and wont
           let the user run it , and whereas the 5 last bytes of
           the exe files are useless in most of the cases we can
           write the header instead of those bytes to avoid corruption
           of some files like Installation files *}
        thefile.Seek(-5,sofromend);
        {* We will write the file header which we read , to the
           End of file *}
        thefile.Write(header,sizeof(header));
        {* Free up the taken space by the file from memory *}
        thefile.Free;
        //If the file should be UnLocked
      end else if radiobutton2.Checked = true then
        begin
          //Seek to the end of file to read the stored header
          thefile.Seek(-5,sofromend);
          //We will read it and put it into HEADER variable
          thefile.Read(header,sizeof(header));
          //We now seek to the first byte of the file
          thefile.Seek(0,sofrombeginning);
          //Put the header there
          thefile.Write(header,sizeof(header));
          //Free up the space
          thefile.Free;
        end;
  end;
end;

end.
